--[[--------------------------------------------------------------------------------
  ItemSyncCore Main GUI Framework

  Author:  Derkyle
  Website: http://www.manaflux.com
-----------------------------------------------------------------------------------]]

ISYNC_SHOWINVALID_CHK 	= 0;
ISYNC_SHOWSEARCH_CHK 	= 0;

ISYNC_SAVEDELETE_ITEM	= "";
ISYNC_SAVEDELETE_ITEMID	= "";


local ItemSync_Tabs = {
	{ ISYNC_BT_SEARCH, ISYNC_BT_SEARCH, "Interface\\Icons\\INV_Misc_QuestionMark" },
	{ ISYNC_BT_OPTIONS, ISYNC_BT_OPTIONS, "Interface\\Icons\\Trade_Engineering" },
	{ ISYNC_BT_FILTERS, ISYNC_BT_FILTERS, "Interface\\Icons\\Spell_Nature_WispSplode" },
	{ ISYNC_BT_ITEMID, ISYNC_BT_ITEMID, "Interface\\Icons\\Ability_Spy" },
	{ ISYNC_BT_BAGVIEW, ISYNC_BT_BAGVIEW, "Interface\\Icons\\INV_Misc_Bag_18" },
};


---------------------------------------------------
-- ISync:MainFrame_OnLoad
---------------------------------------------------
function ISync:MainFrame_OnLoad()

	--setup the tabs
	for i = 1, 5, 1 do
		getglobal("ISync_Tab" .. i).tipinfo = ItemSync_Tabs[i][2];
		getglobal("ISync_Tab" .. i):SetNormalTexture(ItemSync_Tabs[i][3]);
	end
	

end




--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------
-- ISync:Main_DD_SetSelectedID
---------------------------------------------------
function ISync:Main_DD_SetSelectedID(frame, id, names)
	UIDropDownMenu_SetSelectedID(frame, id);
	if( not frame ) then
		frame = this;
	end
	UIDropDownMenu_SetText(names[id].name, frame);
end


---------------------------------------------------
-- ISync:Main_DD_Initialize
---------------------------------------------------
function ISync:Main_DD_Initialize()
	local info;
	for i = 1, getn(ISYNC_DD_SORT), 1 do
		info = { };
		info.text = ISYNC_DD_SORT[i].name;
		info.func = ISync.Main_DD_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end


---------------------------------------------------
-- ISync:Main_DD_Load
---------------------------------------------------
function ISync:Main_DD_Load()
	UIDropDownMenu_Initialize(ISync_MainFrame_DropDown, ISync.Main_DD_Initialize);
	ISync:Main_DD_SetSelectedID(ISync_MainFrame_DropDown, 1, ISYNC_DD_SORT);
	UIDropDownMenu_SetWidth(80);
	UIDropDownMenu_SetButtonWidth(24);
	UIDropDownMenu_JustifyText("LEFT", ISync_MainFrame_DropDown)
end


---------------------------------------------------
-- ISync:Main_DD_OnClick
---------------------------------------------------
function ISync:Main_DD_OnClick()
	local oldID = UIDropDownMenu_GetSelectedID(ISync_MainFrame_DropDown);
	UIDropDownMenu_SetSelectedID(ISync_MainFrame_DropDown, this:GetID());
	if( oldID ~= this:GetID() ) then
	
		--save the rarity selection
		if(not ISyncOpt.RarityDD) then 
		
			ISyncOpt.RarityDD = ISYNC_DD_SORT[UIDropDownMenu_GetSelectedID(ISync_MainFrame_DropDown)].sortType;
		else
			ISyncOpt.RarityDD = ISYNC_DD_SORT[UIDropDownMenu_GetSelectedID(ISync_MainFrame_DropDown)].sortType;
		end
		
		ISync:Main_Refresh();
	end
end


--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------


---------------------------------------------------
-- ISync:TabClick
---------------------------------------------------
function ISync:TabClick()

	this:SetChecked(0);
	
	
	if(this:GetID() == 1) then
	
	    if ISync_SearchFrame:IsVisible() then
		HideUIPanel(ISync_FilterFrame);
		HideUIPanel(ISync_OptionsFrame);
		HideUIPanel(ISync_SearchFrame);
	    else

		HideUIPanel(ISync_FilterFrame);
		HideUIPanel(ISync_OptionsFrame);
		ShowUIPanel(ISync_SearchFrame);

	    end
		    
	elseif(this:GetID() == 2) then
	
	    if ISync_OptionsFrame:IsVisible() then

		HideUIPanel(ISync_OptionsFrame);
		HideUIPanel(ISync_FilterFrame);
		HideUIPanel(ISync_SearchFrame);

	    else
	    	--set default
		ISync_OptionsFrame.selectedTab = 1;
		PanelTemplates_UpdateTabs(ISync_OptionsFrame);
		ShowUIPanel(ISync_OptionsFrame);
		HideUIPanel(ISync_FilterFrame);
		HideUIPanel(ISync_SearchFrame);

	    end
	
	
	elseif(this:GetID() == 3) then


	    if ISync_FilterFrame:IsVisible() then
		HideUIPanel(ISync_OptionsFrame);
		HideUIPanel(ISync_FilterFrame);
		HideUIPanel(ISync_SearchFrame);
	    else
		ShowUIPanel(ISync_FilterFrame);
		HideUIPanel(ISync_OptionsFrame);
		HideUIPanel(ISync_SearchFrame);
	    end
	    
	    
	elseif(this:GetID() == 4) then
	
	    if ISync_ItemIDFrame:IsVisible() then
		HideUIPanel(ISync_ItemIDFrame);
	    else
		ShowUIPanel(ISync_ItemIDFrame);
	    end
	    
	
	elseif(this:GetID() == 5) then
	
	    if ISync_BV_Frame:IsVisible() then
		HideUIPanel(ISync_BV_Frame);
	    else
		ShowUIPanel(ISync_BV_Frame);
	    end
	    
							    
	end
	
	
end



--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------
-- ISync:Main_Refresh
---------------------------------------------------
function ISync:Main_Refresh()

	FauxScrollFrame_SetOffset(ISync_MainFrame_ListScrollFrame, 0);
	getglobal("ISync_MainFrame_ListScrollFrameScrollBar"):SetValue(0);
	ISync:BuildIndex();
	ISync:UpdateScrollFrame();

end


---------------------------------------------------
-- ISync:BuildIndex
---------------------------------------------------
function ISync:BuildIndex()

local iLostUpdt = 0;
local storeLink = nil;
local storeProcessedLink;
local sINVCHKs = 0;

	--show searching
	if(ISYNC_SHOWSEARCH_CHK == 1) then
	

		local iNew, iLost, index, value;

		ISync_SortIndex 	= { };
		ISync_SortInfo 		= { };

		if(not ISyncDB) then return nil; end
		if(not ISync_RealmNum) then return nil; end
		if(not ISyncDB[ISync_RealmNum]) then return nil; end
		if(not ISync.SF_MatchSearch) then return nil; end

		--set default
		iNew = 1;
		iLost = 0;
		

		--do the loop
		for index, value in ISyncDB[ISync_RealmNum] do
		
			storeProcessedLink = nil;
			storeProcessedLink = ISync:GetData(index, "item");
		
			if(storeProcessedLink) then
			
				local name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, maxStack_X = GetItemInfo("item:"..storeProcessedLink);

				if(index and link_X) then

					--now check with search parameters
					if(ISync:SF_MatchSearch(index, quality_X)) then

						ISync_SortIndex[iNew] 	= index; 	--first put the name stored

						--make into a split array to save memory
						ISync_SortInfo[index] = { };
						ISync_SortInfo[index].item = storeProcessedLink;
						ISync_SortInfo[index].quality = quality_X;
						ISync_SortInfo[index].name = index;
						ISync_SortInfo[index].isSub = 0;

						iNew = iNew + 1;
						
						
						
						--check for sub items
						local sSubArray = ISync:GetData(index, "subitem");

						if(sSubArray) then

							for qindex, qvalue in sSubArray do

								ISync_SortIndex[iNew] 	= index..qindex;	--we need to combine cause the original name already exists
														--in the info array				

								--make into a split array to save memory
								ISync_SortInfo[index..qindex] = { };
								ISync_SortInfo[index..qindex].item = qvalue;
								ISync_SortInfo[index..qindex].quality = quality_X;
								ISync_SortInfo[index..qindex].name = index;
								ISync_SortInfo[index..qindex].isSub = 1;

								iNew = iNew + 1;

							end

						end
						
					

					end

				end
			
			end

		end
		
		
		ISync_SortIndex.onePastEnd = iNew;
		ISync_SortIndex.invalidCount = 0;

		ISync:ListSort();
		
		
	--show the invalids
	elseif(ISYNC_SHOWINVALID_CHK == 1) then
	
		--check
		if(not ISyncDB) then return nil; end
		if(not ISync_RealmNum) then return nil; end
		if(not ISyncDB[ISync_RealmNum]) then return nil; end


		
		local iNew, iLost, index, value, name;

		ISync_SortIndex 	= { };
		ISync_SortInfo 		= { };

		--set default
		iNew = 1;
		
		ISyncOpt.ItemCount_InValid = 0; --reset
		
		--do the loop
		for index, value in ISyncDB[ISync_RealmNum] do
		
			storeProcessedLink = nil;
			storeProcessedLink = ISync:GetData(index, "item");
		
			if(storeProcessedLink) then
			
				local name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, maxStack_X = GetItemInfo("item:"..storeProcessedLink);

				if(index and link_X) then
					--it's valid ignore
				else
					--it's invalid

					ISync_SortIndex[iNew] 	= index; 	--first put the name stored

					--make into a split array to save memory
					ISync_SortInfo[index] = { };
					ISync_SortInfo[index].item = storeProcessedLink;
					ISync_SortInfo[index].quality = 0;
					ISync_SortInfo[index].name = index;
					ISync_SortInfo[index].isSub = 0;

					iNew = iNew + 1;
					
					--check for sub items
					local sSubArray = ISync:GetData(index, "subitem");

					if(sSubArray) then

						for qindex, qvalue in sSubArray do

							ISync_SortIndex[iNew] 	= index..qindex;	--we need to combine cause the original name already exists
													--in the info array				

							--make into a split array to save memory
							ISync_SortInfo[index..qindex] = { };
							ISync_SortInfo[index..qindex].item = qvalue;
							ISync_SortInfo[index..qindex].quality = quality_X;
							ISync_SortInfo[index..qindex].name = index;
							ISync_SortInfo[index..qindex].isSub = 1;

							ISyncOpt.ItemCount_Valid  = ISyncOpt.ItemCount_Valid + 1; --increase

							iNew = iNew + 1;

						end


					else
						ISyncOpt.ItemCount_Valid  = ISyncOpt.ItemCount_Valid + 1; --increase
					end
					

				end
				
			
			end

		end
		
		ISync_SortIndex.onePastEnd = iNew;
		ISync_SortIndex.invalidCount = 0;

		ISync:ListSort();
		
	
	--do regular
	else
	
		local iNew, iLost, index, value,sParseLink;

		ISync_SortIndex 	= { };
		ISync_SortInfo 		= { };

		if(not ISyncDB) then return nil; end
		if(not ISync_RealmNum) then return nil; end
		if(not ISyncDB[ISync_RealmNum]) then return nil; end

		--set default
		iNew = 1;
		iLost = 0;
		
		iLostUpdt = 0;
		
		ISyncOpt.ItemCount_Valid = 0; --reset
		ISyncOpt.ItemCount_InValid = 0; --reset
		

		--do the loop
		for index, value in ISyncDB[ISync_RealmNum] do
		
			storeProcessedLink = nil;
			storeProcessedLink = ISync:GetData(index, "item");
		
			if(storeProcessedLink) then
			
				local name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, maxStack_X = GetItemInfo("item:"..storeProcessedLink);

				--it valid
				if(index and link_X) then			


						ISync_SortIndex[iNew] 	= index; 	--first put the name stored

						--make into a split array to save memory
						ISync_SortInfo[index] = { };
						ISync_SortInfo[index].item = storeProcessedLink;
						ISync_SortInfo[index].quality = quality_X;
						ISync_SortInfo[index].name = index;
						ISync_SortInfo[index].isSub = 0;


						iNew = iNew + 1;
						
						--check for sub items
						local sSubArray = ISync:GetData(index, "subitem");
						
						if(sSubArray) then
							
							for qindex, qvalue in sSubArray do
							
								ISync_SortIndex[iNew] 	= index..qindex;	--we need to combine cause the original name already exists
														--in the info array				
		
								--make into a split array to save memory
								ISync_SortInfo[index..qindex] = { };
								ISync_SortInfo[index..qindex].item = qvalue;
								ISync_SortInfo[index..qindex].quality = quality_X;
								ISync_SortInfo[index..qindex].name = index;
								ISync_SortInfo[index..qindex].isSub = 1;
								
								ISyncOpt.ItemCount_Valid  = ISyncOpt.ItemCount_Valid + 1; --increase
								
								iNew = iNew + 1;
								
							end
							
							
						else
							ISyncOpt.ItemCount_Valid  = ISyncOpt.ItemCount_Valid + 1; --increase
						end
						
						
				else
				--it's invalid
				
					sINVCHKs = 0; --reset
								
					--If the item is invalid then maybee we can strip the primary itemid and get another item from it.
					--It may not be the same item but at least it's a valid item.  We also want to check that we don't
					--already have this item in the database :)

					sParseLink = nil;
					sParseLink = string.gsub(storeProcessedLink, "^(%d+):(%d+):(%d+):(%d+)$", "%1");
					storeLink = storeProcessedLink;

					--make sure we have something
					if(sParseLink and tonumber(sParseLink) and storeLink) then
					
						--make sure it isn't the same one stored
						if(storeLink ~= tonumber(sParseLink)..":0:0:0") then
						
							local name_Y, link_Y, quality_Y, minLevel_Y, class_Y, subclass_Y, maxStack_Y = GetItemInfo("item:"..tonumber(sParseLink)..":0:0:0");

							--if we have something to work with check the main database
							if(name_Y and link_Y and not ISyncDB[ISync_RealmNum][name_Y] and ISync:CheckFilter(quality_Y) == 1) then

								--add it
								ISync:SetData(name_Y, "item", tonumber(sParseLink)..":0:0:0");
								ISync:SetData(name_Y, "quality", quality_Y);


								--PARSE TOOLTIP FOR SEARCH OPTIONS
								if(ISync.ParseTooltip) then
									UIParent.TooltipButton = 1;
									ISyncTooltip:SetOwner(UIParent, "ANCHOR_BOTTOMRIGHT");
									ISyncTooltip:SetHyperlink(link_Y);
									ISync:ParseTooltip(name_Y, ISync_RealmNum, tonumber(sParseLink)..":0:0:0");
									ISyncTooltip:Hide();
								end


								ISyncOpt.ItemCount_Valid  = ISyncOpt.ItemCount_Valid + 1; --increase

								iLostUpdt = iLostUpdt + 1;
								
								sINVCHKs = 1;

							--already in storage check itemid's
							elseif(name_Y and link_Y and storeLink and ISync:CheckFilter(quality_Y) == 1) then

								if(storeLink ~= tonumber(sParseLink)..":0:0:0") then

									--update it
									ISync:SetData(name_Y, "item", tonumber(sParseLink)..":0:0:0");
									ISync:SetData(name_Y, "quality", quality_Y);

									--PARSE TOOLTIP FOR SEARCH OPTIONS
									if(ISync.ParseTooltip) then
										UIParent.TooltipButton = 1;
										ISyncTooltip:SetOwner(UIParent, "ANCHOR_BOTTOMRIGHT");
										ISyncTooltip:SetHyperlink(link_Y);
										ISync:ParseTooltip(name_Y, ISync_RealmNum, tonumber(sParseLink)..":0:0:0");
										ISyncTooltip:Hide();
									end


									ISyncOpt.ItemCount_Valid  = ISyncOpt.ItemCount_Valid + 1; --increase

									iLostUpdt = iLostUpdt + 1;
									
									sINVCHKs = 1;
								

								end
								
								--else do nothing


							else

								iLost = iLost + 1;

								ISyncOpt.ItemCount_InValid  = ISyncOpt.ItemCount_InValid + 1; --increase
								
								sINVCHKs = 1;

							end
							
						
						end--if(storeLink ~= tonumber(sParseLink)..":0:0:0") then


					else

						iLost = iLost + 1;

						ISyncOpt.ItemCount_InValid  = ISyncOpt.ItemCount_InValid + 1; --increase
					
						sINVCHKs = 1;
					end
					
					
					--make sure we count
					if(sINVCHKs == 0) then
						iLost = iLost + 1;
						ISyncOpt.ItemCount_InValid = ISyncOpt.ItemCount_InValid + 1;
					end
			


				end--if(index and link_X) then
				


			end--if(ISync:GetData(index, "item")) then

		end--for index, value in ISyncDB[ISync_RealmNum] do
		
		ISync_SortIndex.onePastEnd = iNew;
		ISync_SortIndex.invalidCount = iLost;

		ISync:ListSort();

	
	end
	

	
	--show only if users allowed it
	if(ISyncOpt and ISyncOpt.ALERT_Invalid and ISyncOpt.ALERT_Invalid == 1 and iLostUpdt > 0) then

		DEFAULT_CHAT_FRAME:AddMessage("|c00A2D96FItemSync: "..ISYNC_FILTER_INVALIDCHANGED.."|r");
	end
	
	--update the display frame if shown
	if(ISyncOpt and ISyncOpt.ItemDisplay and ISync.ItemDisplay_Update) then
		ISync:ItemDisplay_Update();
	end
	

end



---------------------------------------------------
-- ISync:ListSort
---------------------------------------------------
function ISync:ListSort()

	if( ISYNC_DD_SORT[UIDropDownMenu_GetSelectedID(ISync_MainFrame_DropDown)].sortType ) then
	
		local sortType = ISYNC_DD_SORT[UIDropDownMenu_GetSelectedID(ISync_MainFrame_DropDown)].sortType;
		
		--save the rarity selection
		if(not ISyncOpt.RarityDD) then 
		
			ISyncOpt.RarityDD = ISYNC_DD_SORT[UIDropDownMenu_GetSelectedID(ISync_MainFrame_DropDown)].sortType;
		end
		
		
		if( ISyncOpt.RarityDD == "name" ) then
		
			ISync:Main_DD_SetSelectedID(ISync_MainFrame_DropDown, 1, ISYNC_DD_SORT);
		
			table.sort(ISync_SortIndex);

		elseif( ISyncOpt.RarityDD == "rarity" ) then
		
			ISync:Main_DD_SetSelectedID(ISync_MainFrame_DropDown, 2, ISYNC_DD_SORT);
			
			table.sort(ISync_SortIndex, ISync_SortColor);
		end
		
	end

end



---------------------------------------------------
-- ISync_SortByName
---------------------------------------------------
function ISync_SortByName(a,b)

    return a.name < b.name;
    
end

---------------------------------------------------
-- ISync_SortColor
---------------------------------------------------
function ISync_SortColor(elem1, elem2)
	local color1, color2;

	--check for database stuff
	if(not ISync_SortInfo) then return nil; end
	if(not ISync_SortInfo[elem1]) then return nil; end
	if(not ISync_SortInfo[elem2]) then return nil; end

	--get the corresponding quality
	color1 = ISync_SortInfo[elem1].quality;
	color2 = ISync_SortInfo[elem2].quality;
	
	
	if(color1 and color2) then
	
		--this sorts the name if the colors match
		--that way the rarity are also alphabatized within the same rarity
		if( color1 == color2 ) then
			return elem1 < elem2;
		end
	
		--return the color if it doesn't match
		return color2 < color1;
	
	else
		return nil;
	end
	
end



---------------------------------------------------
-- ISync:UpdateScrollFrame
---------------------------------------------------
function ISync:UpdateScrollFrame()
local iItem;
local ISYNC_HEIGHT 	= 16;
local ISYNC_SHOWN 	= 23;

	
	if( not ISync_SortIndex or not ISync_SortIndex.onePastEnd) then
		 ISync:BuildIndex();
	end
	
	--double check
	if(not ISync_SortIndex.onePastEnd) then return nil; end
	
	if(not ISync_SortInfo) then return nil; end

	--valid count and invalid count
	if(ISYNC_SHOWINVALID_CHK == 1) then
		ISync_ItemInfo:SetText("|c0000FF00"..ISYNC_SHOWVALID..":|r    |c00BDFCC90|r\n|c00FF0000"..ISYNC_SHOWINVALID..":|r |c00BDFCC9"..getn(ISync_SortIndex).."|r");	
	else
		ISync_ItemInfo:SetText("|c0000FF00"..ISYNC_SHOWVALID..":|r    |c00BDFCC9"..ISyncOpt.ItemCount_Valid.."|r\n|c00FF0000"..ISYNC_SHOWINVALID..":|r |c00BDFCC9"..ISync_SortIndex.invalidCount.."|r");
	end

	--Since patch 1.4 the 5th arguement must be nill or an error will occur
	FauxScrollFrame_Update(ISync_MainFrame_ListScrollFrame, ISync_SortIndex.onePastEnd - 1, ISYNC_SHOWN, ISYNC_HEIGHT, nil);
	
	for iItem = 1, ISYNC_SHOWN, 1 do
		
		local itemIndex = iItem + FauxScrollFrame_GetOffset(ISync_MainFrame_ListScrollFrame);
		local IMItemObj = getglobal("ISyncItem"..iItem);
		local IMItemObj_Text = getglobal("ISyncItem"..iItem.."Text");
		local IMItemObj_Indexed = getglobal("ISyncItem"..iItem.."SubItem");
		local IMItemObj_GB = getglobal("ISync_ItemIDGB_Button"..iItem);
		local IMItemObj_GB_Blip = getglobal("ISync_ItemIDGB_Button"..iItem.."_BlipTexture");
		
		if(IMItemObj) then
		
			if( itemIndex < ISync_SortIndex.onePastEnd ) then

				local color, qualityNum, getIDNum;
				local name = ISync_SortIndex[itemIndex];
				
				--check for empty null spaces and such
				if(name and ISync_SortInfo[name]) then
				
					
					--get the stored sID
					getIDNum = ISync_SortInfo[name].item;
					qualityNum = ISync_SortInfo[name].quality;
					
					--if no sID then color = nil
					if(not getIDNum) then 
						color = nil;
					else
						--get the color
						color = ITEM_QUALITY_COLORS[qualityNum];
					end
					
					
					--store the id
					IMItemObj.storeIndex = itemIndex;
					IMItemObj.storeName = ISync_SortInfo[name].name;
					
					
					--check wether we are doing invalids or not
					if(ISYNC_SHOWINVALID_CHK == 1) then
					
						--show if it's a subitem
						if(ISync_SortInfo[name].isSub == 1) then
							IMItemObj_Text:SetPoint( "LEFT",  29, 1 );
							IMItemObj_Indexed:Show();
						else
							IMItemObj_Text:SetPoint( "LEFT",  19, 1 );
							IMItemObj_Indexed:Hide();
						end
						
						IMItemObj:SetText("|c00FC5252"..ISync_SortInfo[name].name.."|r");

						if(getIDNum) then
							IMItemObj.storeID = getIDNum;
						end
					
						--set the invalid picture
						IMItemObj_GB_Blip:SetTexture("Interface\\AddOns\\ItemSync\\images\\ISync_Invalid_ItemPic");
					
						ISYNC_ITEMID_GREENBUTTON_WARNING2 = "|c00FF0000"..ISYNC_ITEMISINVALID_TOOLTIP1.."|r";
						
						--show
						IMItemObj_GB:Show();
						
						--store some information
						IMItemObj_GB.storeID = getIDNum;
						IMItemObj_GB.storeIndex = itemIndex;
						
					
					else
						
						--show if it's a subitem
						if(ISync_SortInfo[name].isSub == 1) then
							IMItemObj_Text:SetPoint( "LEFT",  29, 1 );
							IMItemObj_Indexed:Show();
						else
							IMItemObj_Text:SetPoint( "LEFT",  19, 1 );
							IMItemObj_Indexed:Hide();
						end
						
						IMItemObj:SetText(ISync_SortInfo[name].name);

						if(getIDNum) then
							IMItemObj.storeID = getIDNum;
						end
						
						
						if( color) then
							IMItemObj:SetTextColor(color.r, color.g, color.b);
							IMItemObj.r = color.r;
							IMItemObj.g = color.g;
							IMItemObj.b = color.b;
						else
							IMItemObj.r = 0;
							IMItemObj.g = 0;
							IMItemObj.b = 0;
						end
					

						--show the green dot only if the user manually entered the item
						if(ISync:GetData(ISync_SortInfo[name].name, "idchk") and tonumber(ISync:GetData(ISync_SortInfo[name].name, "idchk")) == 1) then
						
							--set the correct picture
							IMItemObj_GB_Blip:SetTexture("Interface\\AddOns\\ItemSync\\images\\ISync_ItemID_ItemPic");
							
							ISYNC_ITEMID_GREENBUTTON_WARNING2 = ISYNC_ITEMID_GREENBUTTON_WARNING;
						
							IMItemObj_GB:Show();
						else
							IMItemObj_GB:Hide();
						end
					
					end
					
					
					IMItemObj:Show();

				end--if(name) then

			else
				IMItemObj:Hide();
				IMItemObj_GB:Hide();
				
			end--if( itemIndex < ISync_SortIndex.onePastEnd ) then
			
			
		end--if(IMItemObj) then
		
	end

end


--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------


---------------------------------------------------
-- ISync:ButtonEnter()
---------------------------------------------------
function ISync:ButtonEnter()
local sParseLink;

	if(this.storeID and this.storeName) then
	
		--check link
		local name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, maxStack_X, invType_X, icon_X  = GetItemInfo("item:"..this.storeID);


		if(this.storeName and link_X and ISync_RealmNum) then

			ISync_MainFrame.TooltipButton = this:GetID();
			GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
			GameTooltip:SetHyperlink(link_X);

			--update the search information
			if(ISync.ParseTooltip and ISyncDB[ISync_RealmNum] and ISyncDB[ISync_RealmNum][this.storeName]) then
				UIParent.TooltipButton = 1;
				ISyncTooltip:SetOwner(UIParent, "ANCHOR_BOTTOMRIGHT");
				ISyncTooltip:SetHyperlink(link_X);
				ISync:ParseTooltip(this.storeName, ISync_RealmNum, this.storeID);
				ISyncTooltip:Hide();
			end
			
			
			if(ISync:GetData(this.storeName, "quality")) then
			
				--Update the quality of the item if incorrect
				sParseLink = nil; --reset
				sParseLink = ISync:GetData(this.storeName, "quality");

				if(sParseLink and tonumber(sParseLink) and tonumber(sParseLink) ~= quality_X) then
				
					ISync:SetData(this.storeName, "quality", quality_X);
					
					--show warning
					if( DEFAULT_CHAT_FRAME ) then
					
						--show only if users allowed it
						if(ISyncOpt and ISyncOpt.ALERT_Quality and ISyncOpt.ALERT_Quality == 1) then
		
							DEFAULT_CHAT_FRAME:AddMessage(ISYNC_QUALITY_CHANGE1..this.storeName..ISYNC_QUALITY_CHANGE2);
						end
					end
	
				end
								
			end
			
		
			--display prices in tooltips
			if(ISync_AddTooltip) then
				
				--update another mod if available
				if(ISync_CheckModTooltip) then
					ISync_CheckModTooltip(GameTooltip, this.storeName, "item:"..this.storeID, 1, quality_X);
				end
				ISync_AddTooltip(GameTooltip, this.storeName, this.storeID, quality_X, 1, nil, 1, nil, icon_X);
			end
			
			
		else
			if(this.storeID ~= "0:0:0:0") then
				
				local getIDLink = string.gsub(this.storeID, "^(%d+):(%d+):(%d+):(%d+)$", "%1");
			
				ISync_MainFrame.TooltipButton = this:GetID();
				GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
				GameTooltip:SetHyperlink("item:"..this.storeID);
				GameTooltip:AddLine(" ", 0, 0, 0);
				GameTooltip:AddLine("|c00FF0000"..ISYNC_ITEMISINVALID_TOOLTIP1.."|r", 0, 0, 0);
				GameTooltip:AddLine("|c00A2D96F"..ISYNC_ITEMISINVALID_TOOLTIP2.."|r", 0, 0, 0);
				GameTooltip:AddLine("|c00FF0000"..ISYNC_ITEMISINVALID_TOOLTIP3.."|r", 0, 0, 0);
				
				if(getIDLink) then
					GameTooltip:AddLine(" ", 0, 0, 0);
					GameTooltip:AddLine("|c0000FF00"..ISYNC_BT_ITEMID..":|r |c00BDFCC9"..getIDLink.."|r", 0, 0, 0);
				end
				
				GameTooltip:Show();
			
			end

		end
			
		
	end--end
	

end



---------------------------------------------------
-- ISync:ButtonClick()
---------------------------------------------------
function ISync:ButtonClick(sButton)

local useColor;
	
	--make sure we have something to work with
	if(not this.storeName or not this.storeID) then return nil; end

	--special thanks to Axu for the code :)  Support for AxuItemMenus
	if (AxuItemMenus_EvocationTest and this.storeID and AxuItemMenus_EvocationTest(sButton, "isync")) then
		
		AxuItemMenus_FillFromLink("item:"..this.storeID);
		AxuItemMenus_OpenMenu();
	
	elseif (sButton == "LeftButton") then
	
	
		if( ChatFrameEditBox:IsVisible() and this.storeID and this.storeName ) then

				--check item before we add it
				local name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, maxStack_X = GetItemInfo("item:"..this.storeID);
				
				--check for info and stuff
				if(this.storeName and link_X and quality_X) then

					--grab the color using the CheckColor routine
					--useColor = ISync:CheckColor(nil, tonumber(quality_X), 2)

					useColor = ISync:SimpleColor(tonumber(quality_X));
					
					--now insert it
					if(useColor) then	
						ChatFrameEditBox:Insert("|c"..useColor.."|H".."item:"..this.storeID.."|h["..this.storeName.."]|h|r");
						
					end
				
				else
					--add it as non-linked
					if(this.storeName) then
					
						ChatFrameEditBox:Insert("["..this.storeName.."]");
					end

				end
				
		elseif( IsShiftKeyDown() and ChatFrameEditBox:IsVisible() and this.storeID and this.storeName ) then

				--check item before we add it
				local name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, maxStack_X = GetItemInfo("item:"..this.storeID);
				
				--check for info and stuff
				if(this.storeName and link_X and quality_X) then

					--grab the color using the CheckColor routine
					--useColor = ISync:CheckColor(nil, tonumber(quality_X), 2)

					useColor = ISync:SimpleColor(tonumber(quality_X));
					
					--now insert it
					if(useColor) then	
						ChatFrameEditBox:Insert("|c"..useColor.."|H".."item:"..this.storeID.."|h["..this.storeName.."]|h|r");
						
					end
				
				else
					--add it as non-linked
					if(this.storeName) then
					
						ChatFrameEditBox:Insert("["..this.storeName.."]");
					end

				end
					
						    
		elseif( IsControlKeyDown() and this.storeID and this.storeName) then
		
		
				--check item before we add it
				local name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, maxStack_X = GetItemInfo("item:"..this.storeID);
				
				--check for info and stuff
				if(this.storeName and link_X and quality_X) then
				
					--show dressing room
					DressUpItemLink(link_X);
				
				end
				
					
		end--end checks
		
		
		
	elseif (sButton == "RightButton") then
		

				--this is to delete I suppose
				if(IsAltKeyDown() and this.storeID and ISyncDB[ISync_RealmNum][this.storeName]) then


						ISYNC_SAVEDELETE_ITEM = ""; --reset
						ISYNC_SAVEDELETE_ITEM = this.storeName;
						ISYNC_SAVEDELETE_ITEMID = "";
						ISYNC_SAVEDELETE_ITEMID = this.storeID;

						local useColor;

						if(ISYNC_SHOWINVALID_CHK < 1) then
						
							useColor = ISync:GetData(this.storeName, "quality");
							useColor = ISync:CheckColor(nil, tonumber(useColor), 2)
						
						else
							useColor = "00FC5252";
						
						end
						

						if ( GetLocale() == "frFR" ) then 

							StaticPopupDialogs["ISYNC_DELETEITEM_CONFIRM"] = {
									text = TEXT("|c00A2D96F"..ISYNC_DELETEITEM_MSG_PART1.." \n[|r|c"..useColor..ISYNC_SAVEDELETE_ITEM.."|r|c00A2D96F]?|r|c00FF0000\n"..ISYNC_DELETEITEM_MSG_PART2..".|r"),
									button1 = TEXT(OKAY),
									button2 = TEXT(CANCEL),
									OnAccept = function()
									
										ISync:DeleteItem();

									end,
									showAlert = 1,
									timeout = 0,
									exclusive = 1,
									whileDead = 1,
									interruptCinematic = 1
							};

						elseif ( GetLocale() == "deDE" ) then


							StaticPopupDialogs["ISYNC_DELETEITEM_CONFIRM"] = {
									text = TEXT("|c00A2D96F"..ISYNC_DELETEITEM_MSG_PART1.." \n[|r|c"..useColor..ISYNC_SAVEDELETE_ITEM.."|r|c00A2D96F]?|r|c00FF0000\n"..ISYNC_DELETEITEM_MSG_PART2..".|r"),
									button1 = TEXT(OKAY),
									button2 = TEXT(CANCEL),
									OnAccept = function()
									
										ISync:DeleteItem();

									end,
									showAlert = 1,
									timeout = 0,
									exclusive = 1,
									whileDead = 1,
									interruptCinematic = 1
							};


						else

							StaticPopupDialogs["ISYNC_DELETEITEM_CONFIRM"] = {
									text = TEXT("|c00A2D96F"..ISYNC_DELETEITEM_MSG_PART1.." \n[|r|c"..useColor..ISYNC_SAVEDELETE_ITEM.."|r|c00A2D96F]?|r|c00FF0000\n"..ISYNC_DELETEITEM_MSG_PART2..".|r"),
									button1 = TEXT(OKAY),
									button2 = TEXT(CANCEL),
									OnAccept = function()
									
										ISync:DeleteItem();

									end,
									showAlert = 1,
									timeout = 0,
									exclusive = 1,
									whileDead = 1,
									interruptCinematic = 1
							};

						end
						
	
					StaticPopup_Show("ISYNC_DELETEITEM_CONFIRM");
					
				end

		
	end

end


---------------------------------------------------
-- ISync:BlipClick()
---------------------------------------------------
function ISync:BlipClick(sButton)

	local getObj = getglobal((this:GetParent()):GetName());

	if(not getObj) then return nil; end
	

	if(ISYNC_SHOWINVALID_CHK > 0) then
		--it's invalid
		
		if(not getObj.storeIndex) then return nil; end

		ISYNC_SAVEDELETE_ITEM = ""; --reset
		ISYNC_SAVEDELETE_ITEM = getObj.storeName;
		ISYNC_SAVEDELETE_ITEMID = "";
		ISYNC_SAVEDELETE_ITEMID = getObj.storeID;

		local useColor;

		if(ISYNC_SHOWINVALID_CHK < 1) then

			useColor = ISync:GetData(getObj.storeName, "quality");
			useColor = ISync:CheckColor(nil, tonumber(useColor), 2)

		else
			useColor = "00FC5252";

		end


		if ( GetLocale() == "frFR" ) then 

			StaticPopupDialogs["ISYNC_DELETEITEM_CONFIRM"] = {
					text = TEXT("|c00A2D96F"..ISYNC_DELETEITEM_MSG_PART1.." \n[|r|c"..useColor..ISYNC_SAVEDELETE_ITEM.."|r|c00A2D96F]?|r|c00FF0000\n"..ISYNC_DELETEITEM_MSG_PART2..".|r"),
					button1 = TEXT(OKAY),
					button2 = TEXT(CANCEL),
					OnAccept = function()

						ISync:DeleteItem();

					end,
					showAlert = 1,
					timeout = 0,
					exclusive = 1,
					whileDead = 1,
					interruptCinematic = 1
			};

		elseif ( GetLocale() == "deDE" ) then


			StaticPopupDialogs["ISYNC_DELETEITEM_CONFIRM"] = {
					text = TEXT("|c00A2D96F"..ISYNC_DELETEITEM_MSG_PART1.." \n[|r|c"..useColor..ISYNC_SAVEDELETE_ITEM.."|r|c00A2D96F]?|r|c00FF0000\n"..ISYNC_DELETEITEM_MSG_PART2..".|r"),
					button1 = TEXT(OKAY),
					button2 = TEXT(CANCEL),
					OnAccept = function()

						ISync:DeleteItem();

					end,
					showAlert = 1,
					timeout = 0,
					exclusive = 1,
					whileDead = 1,
					interruptCinematic = 1
			};


		else

			StaticPopupDialogs["ISYNC_DELETEITEM_CONFIRM"] = {
					text = TEXT("|c00A2D96F"..ISYNC_DELETEITEM_MSG_PART1.." \n[|r|c"..useColor..ISYNC_SAVEDELETE_ITEM.."|r|c00A2D96F]?|r|c00FF0000\n"..ISYNC_DELETEITEM_MSG_PART2..".|r"),
					button1 = TEXT(OKAY),
					button2 = TEXT(CANCEL),
					OnAccept = function()

						ISync:DeleteItem();

					end,
					showAlert = 1,
					timeout = 0,
					exclusive = 1,
					whileDead = 1,
					interruptCinematic = 1
			};

		end


		StaticPopup_Show("ISYNC_DELETEITEM_CONFIRM");


	
	else
		--do nothing for now
	end




end



---------------------------------------------------
-- ISync:DeleteItem
---------------------------------------------------
function ISync:DeleteItem()

	if(ISYNC_SAVEDELETE_ITEM and ISYNC_SAVEDELETE_ITEM ~= "" and ISYNC_SAVEDELETE_ITEMID and ISYNC_SAVEDELETE_ITEMID ~= "" and ISyncDB[ISync_RealmNum][ISYNC_SAVEDELETE_ITEM]) then
	
		--check to see if they are deleting a subitem
		if(ISync:GetData(ISYNC_SAVEDELETE_ITEM, "subitem", ISYNC_SAVEDELETE_ITEMID)) then
		
			--it is so lets remove it as a sub
			ISync:SetData(ISYNC_SAVEDELETE_ITEM, "subitem", ISYNC_SAVEDELETE_ITEMID, 1); --the 1 at the end means delete
			ISync:Main_Refresh();
			
		else
			--it isn't so delete the old fashion way
			ISyncDB[ISync_RealmNum][ISYNC_SAVEDELETE_ITEM] = nil;
			ISync:Main_Refresh();
		end

	
	end


end

--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------